t / test-lib.shon commit notes: implement helpers needed for note copying during rewrite (6956f85)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# if --tee was passed, write the output not only to the terminal, but
   7# additionally to the file test-results/$BASENAME.out, too.
   8case "$GIT_TEST_TEE_STARTED, $* " in
   9done,*)
  10        # do not redirect again
  11        ;;
  12*' --tee '*|*' --va'*)
  13        mkdir -p test-results
  14        BASE=test-results/$(basename "$0" .sh)
  15        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  16         echo $? > $BASE.exit) | tee $BASE.out
  17        test "$(cat $BASE.exit)" = 0
  18        exit
  19        ;;
  20esac
  21
  22# Keep the original TERM for say_color
  23ORIGINAL_TERM=$TERM
  24
  25# For repeatability, reset the environment to known value.
  26LANG=C
  27LC_ALL=C
  28PAGER=cat
  29TZ=UTC
  30TERM=dumb
  31export LANG LC_ALL PAGER TERM TZ
  32EDITOR=:
  33unset VISUAL
  34unset GIT_EDITOR
  35unset AUTHOR_DATE
  36unset AUTHOR_EMAIL
  37unset AUTHOR_NAME
  38unset COMMIT_AUTHOR_EMAIL
  39unset COMMIT_AUTHOR_NAME
  40unset EMAIL
  41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  42unset GIT_AUTHOR_DATE
  43GIT_AUTHOR_EMAIL=author@example.com
  44GIT_AUTHOR_NAME='A U Thor'
  45unset GIT_COMMITTER_DATE
  46GIT_COMMITTER_EMAIL=committer@example.com
  47GIT_COMMITTER_NAME='C O Mitter'
  48unset GIT_DIFF_OPTS
  49unset GIT_DIR
  50unset GIT_WORK_TREE
  51unset GIT_EXTERNAL_DIFF
  52unset GIT_INDEX_FILE
  53unset GIT_OBJECT_DIRECTORY
  54unset GIT_CEILING_DIRECTORIES
  55unset SHA1_FILE_DIRECTORIES
  56unset SHA1_FILE_DIRECTORY
  57unset GIT_NOTES_REF
  58unset GIT_NOTES_DISPLAY_REF
  59unset GIT_NOTES_REWRITE_REF
  60unset GIT_NOTES_REWRITE_MODE
  61GIT_MERGE_VERBOSITY=5
  62export GIT_MERGE_VERBOSITY
  63export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  64export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  65export EDITOR
  66GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
  67
  68# Protect ourselves from common misconfiguration to export
  69# CDPATH into the environment
  70unset CDPATH
  71
  72case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  73        1|2|true)
  74                echo "* warning: Some tests will not work if GIT_TRACE" \
  75                        "is set as to trace on STDERR ! *"
  76                echo "* warning: Please set GIT_TRACE to something" \
  77                        "other than 1, 2 or true ! *"
  78                ;;
  79esac
  80
  81# Each test should start with something like this, after copyright notices:
  82#
  83# test_description='Description of this test...
  84# This test checks if command xyzzy does the right thing...
  85# '
  86# . ./test-lib.sh
  87[ "x$ORIGINAL_TERM" != "xdumb" ] && (
  88                TERM=$ORIGINAL_TERM &&
  89                export TERM &&
  90                [ -t 1 ] &&
  91                tput bold >/dev/null 2>&1 &&
  92                tput setaf 1 >/dev/null 2>&1 &&
  93                tput sgr0 >/dev/null 2>&1
  94        ) &&
  95        color=t
  96
  97while test "$#" -ne 0
  98do
  99        case "$1" in
 100        -d|--d|--de|--deb|--debu|--debug)
 101                debug=t; shift ;;
 102        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 103                immediate=t; shift ;;
 104        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 105                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 106        -h|--h|--he|--hel|--help)
 107                help=t; shift ;;
 108        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 109                verbose=t; shift ;;
 110        -q|--q|--qu|--qui|--quie|--quiet)
 111                quiet=t; shift ;;
 112        --with-dashes)
 113                with_dashes=t; shift ;;
 114        --no-color)
 115                color=; shift ;;
 116        --no-python)
 117                # noop now...
 118                shift ;;
 119        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 120                valgrind=t; verbose=t; shift ;;
 121        --tee)
 122                shift ;; # was handled already
 123        --root=*)
 124                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 125                shift ;;
 126        *)
 127                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 128        esac
 129done
 130
 131if test -n "$color"; then
 132        say_color () {
 133                (
 134                TERM=$ORIGINAL_TERM
 135                export TERM
 136                case "$1" in
 137                        error) tput bold; tput setaf 1;; # bold red
 138                        skip)  tput bold; tput setaf 2;; # bold green
 139                        pass)  tput setaf 2;;            # green
 140                        info)  tput setaf 3;;            # brown
 141                        *) test -n "$quiet" && return;;
 142                esac
 143                shift
 144                printf "* %s" "$*"
 145                tput sgr0
 146                echo
 147                )
 148        }
 149else
 150        say_color() {
 151                test -z "$1" && test -n "$quiet" && return
 152                shift
 153                echo "* $*"
 154        }
 155fi
 156
 157error () {
 158        say_color error "error: $*"
 159        GIT_EXIT_OK=t
 160        exit 1
 161}
 162
 163say () {
 164        say_color info "$*"
 165}
 166
 167test "${test_description}" != "" ||
 168error "Test script did not set test_description."
 169
 170if test "$help" = "t"
 171then
 172        echo "$test_description"
 173        exit 0
 174fi
 175
 176exec 5>&1
 177if test "$verbose" = "t"
 178then
 179        exec 4>&2 3>&1
 180else
 181        exec 4>/dev/null 3>/dev/null
 182fi
 183
 184test_failure=0
 185test_count=0
 186test_fixed=0
 187test_broken=0
 188test_success=0
 189
 190die () {
 191        code=$?
 192        if test -n "$GIT_EXIT_OK"
 193        then
 194                exit $code
 195        else
 196                echo >&5 "FATAL: Unexpected exit with code $code"
 197                exit 1
 198        fi
 199}
 200
 201GIT_EXIT_OK=
 202trap 'die' EXIT
 203
 204# The semantics of the editor variables are that of invoking
 205# sh -c "$EDITOR \"$@\"" files ...
 206#
 207# If our trash directory contains shell metacharacters, they will be
 208# interpreted if we just set $EDITOR directly, so do a little dance with
 209# environment variables to work around this.
 210#
 211# In particular, quoting isn't enough, as the path may contain the same quote
 212# that we're using.
 213test_set_editor () {
 214        FAKE_EDITOR="$1"
 215        export FAKE_EDITOR
 216        EDITOR='"$FAKE_EDITOR"'
 217        export EDITOR
 218}
 219
 220test_decode_color () {
 221        sed     -e 's/.\[1m/<WHITE>/g' \
 222                -e 's/.\[31m/<RED>/g' \
 223                -e 's/.\[32m/<GREEN>/g' \
 224                -e 's/.\[33m/<YELLOW>/g' \
 225                -e 's/.\[34m/<BLUE>/g' \
 226                -e 's/.\[35m/<MAGENTA>/g' \
 227                -e 's/.\[36m/<CYAN>/g' \
 228                -e 's/.\[m/<RESET>/g'
 229}
 230
 231test_tick () {
 232        if test -z "${test_tick+set}"
 233        then
 234                test_tick=1112911993
 235        else
 236                test_tick=$(($test_tick + 60))
 237        fi
 238        GIT_COMMITTER_DATE="$test_tick -0700"
 239        GIT_AUTHOR_DATE="$test_tick -0700"
 240        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 241}
 242
 243# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 244#
 245# This will commit a file with the given contents and the given commit
 246# message.  It will also add a tag with <message> as name.
 247#
 248# Both <file> and <contents> default to <message>.
 249
 250test_commit () {
 251        file=${2:-"$1.t"}
 252        echo "${3-$1}" > "$file" &&
 253        git add "$file" &&
 254        test_tick &&
 255        git commit -m "$1" &&
 256        git tag "$1"
 257}
 258
 259# Call test_merge with the arguments "<message> <commit>", where <commit>
 260# can be a tag pointing to the commit-to-merge.
 261
 262test_merge () {
 263        test_tick &&
 264        git merge -m "$1" "$2" &&
 265        git tag "$1"
 266}
 267
 268# This function helps systems where core.filemode=false is set.
 269# Use it instead of plain 'chmod +x' to set or unset the executable bit
 270# of a file in the working directory and add it to the index.
 271
 272test_chmod () {
 273        chmod "$@" &&
 274        git update-index --add "--chmod=$@"
 275}
 276
 277# Use test_set_prereq to tell that a particular prerequisite is available.
 278# The prerequisite can later be checked for in two ways:
 279#
 280# - Explicitly using test_have_prereq.
 281#
 282# - Implicitly by specifying the prerequisite tag in the calls to
 283#   test_expect_{success,failure,code}.
 284#
 285# The single parameter is the prerequisite tag (a simple word, in all
 286# capital letters by convention).
 287
 288test_set_prereq () {
 289        satisfied="$satisfied$1 "
 290}
 291satisfied=" "
 292
 293test_have_prereq () {
 294        case $satisfied in
 295        *" $1 "*)
 296                : yes, have it ;;
 297        *)
 298                ! : nope ;;
 299        esac
 300}
 301
 302# You are not expected to call test_ok_ and test_failure_ directly, use
 303# the text_expect_* functions instead.
 304
 305test_ok_ () {
 306        test_success=$(($test_success + 1))
 307        say_color "" "  ok $test_count: $@"
 308}
 309
 310test_failure_ () {
 311        test_failure=$(($test_failure + 1))
 312        say_color error "FAIL $test_count: $1"
 313        shift
 314        echo "$@" | sed -e 's/^/        /'
 315        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 316}
 317
 318test_known_broken_ok_ () {
 319        test_fixed=$(($test_fixed+1))
 320        say_color "" "  FIXED $test_count: $@"
 321}
 322
 323test_known_broken_failure_ () {
 324        test_broken=$(($test_broken+1))
 325        say_color skip "  still broken $test_count: $@"
 326}
 327
 328test_debug () {
 329        test "$debug" = "" || eval "$1"
 330}
 331
 332test_run_ () {
 333        eval >&3 2>&4 "$1"
 334        eval_ret="$?"
 335        return 0
 336}
 337
 338test_skip () {
 339        test_count=$(($test_count+1))
 340        to_skip=
 341        for skp in $GIT_SKIP_TESTS
 342        do
 343                case $this_test.$test_count in
 344                $skp)
 345                        to_skip=t
 346                esac
 347        done
 348        if test -z "$to_skip" && test -n "$prereq" &&
 349           ! test_have_prereq "$prereq"
 350        then
 351                to_skip=t
 352        fi
 353        case "$to_skip" in
 354        t)
 355                say_color skip >&3 "skipping test: $@"
 356                say_color skip "skip $test_count: $1"
 357                : true
 358                ;;
 359        *)
 360                false
 361                ;;
 362        esac
 363}
 364
 365test_expect_failure () {
 366        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 367        test "$#" = 2 ||
 368        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 369        if ! test_skip "$@"
 370        then
 371                say >&3 "checking known breakage: $2"
 372                test_run_ "$2"
 373                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 374                then
 375                        test_known_broken_ok_ "$1"
 376                else
 377                        test_known_broken_failure_ "$1"
 378                fi
 379        fi
 380        echo >&3 ""
 381}
 382
 383test_expect_success () {
 384        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 385        test "$#" = 2 ||
 386        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 387        if ! test_skip "$@"
 388        then
 389                say >&3 "expecting success: $2"
 390                test_run_ "$2"
 391                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 392                then
 393                        test_ok_ "$1"
 394                else
 395                        test_failure_ "$@"
 396                fi
 397        fi
 398        echo >&3 ""
 399}
 400
 401test_expect_code () {
 402        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 403        test "$#" = 3 ||
 404        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 405        if ! test_skip "$@"
 406        then
 407                say >&3 "expecting exit code $1: $3"
 408                test_run_ "$3"
 409                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 410                then
 411                        test_ok_ "$2"
 412                else
 413                        test_failure_ "$@"
 414                fi
 415        fi
 416        echo >&3 ""
 417}
 418
 419# test_external runs external test scripts that provide continuous
 420# test output about their progress, and succeeds/fails on
 421# zero/non-zero exit code.  It outputs the test output on stdout even
 422# in non-verbose mode, and announces the external script with "* run
 423# <n>: ..." before running it.  When providing relative paths, keep in
 424# mind that all scripts run in "trash directory".
 425# Usage: test_external description command arguments...
 426# Example: test_external 'Perl API' perl ../path/to/test.pl
 427test_external () {
 428        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 429        test "$#" = 3 ||
 430        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 431        descr="$1"
 432        shift
 433        if ! test_skip "$descr" "$@"
 434        then
 435                # Announce the script to reduce confusion about the
 436                # test output that follows.
 437                say_color "" " run $test_count: $descr ($*)"
 438                # Run command; redirect its stderr to &4 as in
 439                # test_run_, but keep its stdout on our stdout even in
 440                # non-verbose mode.
 441                "$@" 2>&4
 442                if [ "$?" = 0 ]
 443                then
 444                        test_ok_ "$descr"
 445                else
 446                        test_failure_ "$descr" "$@"
 447                fi
 448        fi
 449}
 450
 451# Like test_external, but in addition tests that the command generated
 452# no output on stderr.
 453test_external_without_stderr () {
 454        # The temporary file has no (and must have no) security
 455        # implications.
 456        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 457        stderr="$tmp/git-external-stderr.$$.tmp"
 458        test_external "$@" 4> "$stderr"
 459        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 460        descr="no stderr: $1"
 461        shift
 462        say >&3 "expecting no stderr from previous command"
 463        if [ ! -s "$stderr" ]; then
 464                rm "$stderr"
 465                test_ok_ "$descr"
 466        else
 467                if [ "$verbose" = t ]; then
 468                        output=`echo; echo Stderr is:; cat "$stderr"`
 469                else
 470                        output=
 471                fi
 472                # rm first in case test_failure exits.
 473                rm "$stderr"
 474                test_failure_ "$descr" "$@" "$output"
 475        fi
 476}
 477
 478# This is not among top-level (test_expect_success | test_expect_failure)
 479# but is a prefix that can be used in the test script, like:
 480#
 481#       test_expect_success 'complain and die' '
 482#           do something &&
 483#           do something else &&
 484#           test_must_fail git checkout ../outerspace
 485#       '
 486#
 487# Writing this as "! git checkout ../outerspace" is wrong, because
 488# the failure could be due to a segv.  We want a controlled failure.
 489
 490test_must_fail () {
 491        "$@"
 492        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 493}
 494
 495# test_cmp is a helper function to compare actual and expected output.
 496# You can use it like:
 497#
 498#       test_expect_success 'foo works' '
 499#               echo expected >expected &&
 500#               foo >actual &&
 501#               test_cmp expected actual
 502#       '
 503#
 504# This could be written as either "cmp" or "diff -u", but:
 505# - cmp's output is not nearly as easy to read as diff -u
 506# - not all diff versions understand "-u"
 507
 508test_cmp() {
 509        $GIT_TEST_CMP "$@"
 510}
 511
 512# Most tests can use the created repository, but some may need to create more.
 513# Usage: test_create_repo <directory>
 514test_create_repo () {
 515        test "$#" = 1 ||
 516        error "bug in the test script: not 1 parameter to test-create-repo"
 517        owd=`pwd`
 518        repo="$1"
 519        mkdir -p "$repo"
 520        cd "$repo" || error "Cannot setup test environment"
 521        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 522        error "cannot run git init -- have you built things yet?"
 523        mv .git/hooks .git/hooks-disabled
 524        cd "$owd"
 525}
 526
 527test_done () {
 528        GIT_EXIT_OK=t
 529        test_results_dir="$TEST_DIRECTORY/test-results"
 530        mkdir -p "$test_results_dir"
 531        test_results_path="$test_results_dir/${0%.sh}-$$"
 532
 533        echo "total $test_count" >> $test_results_path
 534        echo "success $test_success" >> $test_results_path
 535        echo "fixed $test_fixed" >> $test_results_path
 536        echo "broken $test_broken" >> $test_results_path
 537        echo "failed $test_failure" >> $test_results_path
 538        echo "" >> $test_results_path
 539
 540        if test "$test_fixed" != 0
 541        then
 542                say_color pass "fixed $test_fixed known breakage(s)"
 543        fi
 544        if test "$test_broken" != 0
 545        then
 546                say_color error "still have $test_broken known breakage(s)"
 547                msg="remaining $(($test_count-$test_broken)) test(s)"
 548        else
 549                msg="$test_count test(s)"
 550        fi
 551        case "$test_failure" in
 552        0)
 553                say_color pass "passed all $msg"
 554
 555                test -d "$remove_trash" &&
 556                cd "$(dirname "$remove_trash")" &&
 557                rm -rf "$(basename "$remove_trash")"
 558
 559                exit 0 ;;
 560
 561        *)
 562                say_color error "failed $test_failure among $msg"
 563                exit 1 ;;
 564
 565        esac
 566}
 567
 568# Test the binaries we have just built.  The tests are kept in
 569# t/ subdirectory and are run in 'trash directory' subdirectory.
 570TEST_DIRECTORY=$(pwd)
 571if test -n "$valgrind"
 572then
 573        make_symlink () {
 574                test -h "$2" &&
 575                test "$1" = "$(readlink "$2")" || {
 576                        # be super paranoid
 577                        if mkdir "$2".lock
 578                        then
 579                                rm -f "$2" &&
 580                                ln -s "$1" "$2" &&
 581                                rm -r "$2".lock
 582                        else
 583                                while test -d "$2".lock
 584                                do
 585                                        say "Waiting for lock on $2."
 586                                        sleep 1
 587                                done
 588                        fi
 589                }
 590        }
 591
 592        make_valgrind_symlink () {
 593                # handle only executables
 594                test -x "$1" || return
 595
 596                base=$(basename "$1")
 597                symlink_target=$TEST_DIRECTORY/../$base
 598                # do not override scripts
 599                if test -x "$symlink_target" &&
 600                    test ! -d "$symlink_target" &&
 601                    test "#!" != "$(head -c 2 < "$symlink_target")"
 602                then
 603                        symlink_target=../valgrind.sh
 604                fi
 605                case "$base" in
 606                *.sh|*.perl)
 607                        symlink_target=../unprocessed-script
 608                esac
 609                # create the link, or replace it if it is out of date
 610                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 611        }
 612
 613        # override all git executables in TEST_DIRECTORY/..
 614        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 615        mkdir -p "$GIT_VALGRIND"/bin
 616        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 617        do
 618                make_valgrind_symlink $file
 619        done
 620        OLDIFS=$IFS
 621        IFS=:
 622        for path in $PATH
 623        do
 624                ls "$path"/git-* 2> /dev/null |
 625                while read file
 626                do
 627                        make_valgrind_symlink "$file"
 628                done
 629        done
 630        IFS=$OLDIFS
 631        PATH=$GIT_VALGRIND/bin:$PATH
 632        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 633        export GIT_VALGRIND
 634elif test -n "$GIT_TEST_INSTALLED" ; then
 635        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 636        error "Cannot run git from $GIT_TEST_INSTALLED."
 637        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 638        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 639else # normal case, use ../bin-wrappers only unless $with_dashes:
 640        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 641        if ! test -x "$git_bin_dir/git" ; then
 642                if test -z "$with_dashes" ; then
 643                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 644                fi
 645                with_dashes=t
 646        fi
 647        PATH="$git_bin_dir:$PATH"
 648        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 649        if test -n "$with_dashes" ; then
 650                PATH="$TEST_DIRECTORY/..:$PATH"
 651        fi
 652fi
 653GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 654unset GIT_CONFIG
 655GIT_CONFIG_NOSYSTEM=1
 656GIT_CONFIG_NOGLOBAL=1
 657export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 658
 659. ../GIT-BUILD-OPTIONS
 660
 661GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 662export GITPERLLIB
 663test -d ../templates/blt || {
 664        error "You haven't built things yet, have you?"
 665}
 666
 667if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 668then
 669        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 670        export GITPYTHONLIB
 671        test -d ../git_remote_helpers/build || {
 672                error "You haven't built git_remote_helpers yet, have you?"
 673        }
 674fi
 675
 676if ! test -x ../test-chmtime; then
 677        echo >&2 'You need to build test-chmtime:'
 678        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 679        exit 1
 680fi
 681
 682# Test repository
 683test="trash directory.$(basename "$0" .sh)"
 684test -n "$root" && test="$root/$test"
 685case "$test" in
 686/*) TRASH_DIRECTORY="$test" ;;
 687 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 688esac
 689test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 690rm -fr "$test" || {
 691        GIT_EXIT_OK=t
 692        echo >&5 "FATAL: Cannot prepare test area"
 693        exit 1
 694}
 695
 696test_create_repo "$test"
 697# Use -P to resolve symlinks in our working directory so that the cwd
 698# in subprocesses like git equals our $PWD (for pathname comparisons).
 699cd -P "$test" || exit 1
 700
 701this_test=${0##*/}
 702this_test=${this_test%%-*}
 703for skp in $GIT_SKIP_TESTS
 704do
 705        to_skip=
 706        for skp in $GIT_SKIP_TESTS
 707        do
 708                case "$this_test" in
 709                $skp)
 710                        to_skip=t
 711                esac
 712        done
 713        case "$to_skip" in
 714        t)
 715                say_color skip >&3 "skipping test $this_test altogether"
 716                say_color skip "skip all tests in $this_test"
 717                test_done
 718        esac
 719done
 720
 721# Provide an implementation of the 'yes' utility
 722yes () {
 723        if test $# = 0
 724        then
 725                y=y
 726        else
 727                y="$*"
 728        fi
 729
 730        while echo "$y"
 731        do
 732                :
 733        done
 734}
 735
 736# Fix some commands on Windows
 737case $(uname -s) in
 738*MINGW*)
 739        # Windows has its own (incompatible) sort and find
 740        sort () {
 741                /usr/bin/sort "$@"
 742        }
 743        find () {
 744                /usr/bin/find "$@"
 745        }
 746        sum () {
 747                md5sum "$@"
 748        }
 749        # git sees Windows-style pwd
 750        pwd () {
 751                builtin pwd -W
 752        }
 753        # no POSIX permissions
 754        # backslashes in pathspec are converted to '/'
 755        # exec does not inherit the PID
 756        ;;
 757*)
 758        test_set_prereq POSIXPERM
 759        test_set_prereq BSLASHPSPEC
 760        test_set_prereq EXECKEEPSPID
 761        ;;
 762esac
 763
 764test -z "$NO_PERL" && test_set_prereq PERL
 765test -z "$NO_PYTHON" && test_set_prereq PYTHON
 766
 767# test whether the filesystem supports symbolic links
 768ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 769rm -f y